#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 1000
static int gr[MAXN][MAXN];

static void
fail (char *fn)
{
  fprintf (stderr, "Chyba v %s\n", fn);
  abort ();
}

static const int maxn[] =
{
  10,
  10,
  10,
  100,
  100,
  300,
  300,
  1000,
  1000,
  1000
};
static const int maxm[] =
{
  45,
  45,
  45,
  1000,
  1000,
  20000,
  20000,
  100000,
  100000,
  100000
};

int main (int argc, char *argv[])
{
  char *fn = argv[1], *b;
  int testno;
  FILE *f;
  int i, n, m;

  b = strchr (fn, '.') + 1;
  testno = atoi (b) - 1;

  if (testno < 0 || testno > 9)
    fail (fn);

  f = fopen (fn, "r");
  if (fscanf (f, "%d%d", &n, &m) != 2)
    fail (fn);

  if (n < 0 || n > maxn[testno]
      || m < 0 || m > maxm[testno])
    fail (fn);

  for (i = 0; i < m; i++)
    {
      int u, v;

      if (fscanf (f, "%d%d", &u, &v) != 2)
	fail (fn);

      u--, v--;
      if (u < 0 || v < 0 || u >= n || v >= n || u == v || gr[u][v])
	fail (fn);

      gr[u][v] = gr[v][u] = 1;
    }

  if (fscanf (f, "%d", &i) == 1)
    fail (fn);

  return 0;
}
