#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void
fail (char *fn)
{
  fprintf (stderr, "Chyba v %s\n", fn);
  abort ();
}

static const int maxn[] =
{
  14,
  14,
  14,
  100,
  100,
  1000,
  1000,
  10000,
  10000,
  10000
};

static const int islast[] =
{
  0,
  0,
  0,
  1,
  0,
  0,
  0,
  1,
  0,
  0
};

int main (int argc, char *argv[])
{
  char *fn = argv[1], *b;
  int testno;
  FILE *f;
  int i, n, last = 0;

  b = strchr (fn, '.') + 1;
  testno = atoi (b) - 1;

  if (testno < 0 || testno > 9)
    fail (fn);

  f = fopen (fn, "r");
  if (fscanf (f, "%d", &n) != 1)
    fail (fn);

  if (n <= 0 || n > maxn[testno])
    fail (fn);

  for (i = 0; i < n; i++)
    {
      int x;

      if (fscanf (f, "%d", &x) != 1)
	fail (fn);

      if (x < 1 || x > last + 1)
	fail (fn);

      if (x == last + 1)
	last++;
      else if (islast[testno])
	fail (fn);
    }

  if (fscanf (f, "%d", &i) == 1)
    fail (fn);

  return 0;
}
