#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void
fail (char *fn)
{
  fprintf (stderr, "Chyba v %s\n", fn);
  abort ();
}

static const int maxn[] =
{
  100,
  5000,
  4000,
  10000,
  30000,
  70000,
  80000,
  100000,
  100000,
  100000
};
static const int maxm[] =
{
  200,
  15000,
  600000,
  1200000,
  1500000,
  2000000,
  3000000,
  4000000,
  5000000,
  6000000
};

int main (int argc, char *argv[])
{
  char *fn = argv[1], *b;
  int testno;
  FILE *f;
  int i, n, m;

  b = strchr (fn, '.') + 1;
  testno = atoi (b) - 1;

  if (testno < 0 || testno > 9)
    fail (fn);

  f = fopen (fn, "r");
  if (fscanf (f, "%d%d", &n, &m) != 2)
    fail (fn);

  if (n < 0 || n > maxn[testno]
      || m < 0 || m > maxm[testno])
    fail (fn);

  for (i = 0; i < m; i++)
    {
      int u, v;

      if (fscanf (f, "%d%d", &u, &v) != 2)
	fail (fn);

      u--, v--;
      if (u < 0 || v < 0 || u >= n || v >= n || u == v)
	fail (fn);
    }

  if (fscanf (f, "%d", &i) == 1)
    fail (fn);

  return 0;
}
