#include <stdio.h>
#include <stdlib.h>
#include <set>

using namespace std;

union TILE
{
	struct {int x, y;};
	long long int l;
	
	bool operator < (const TILE& T) const
	{
		return l < T.l;
	}
	
	TILE() {}
	TILE(int x, int y): x(x), y(y) {}
};

set<TILE> Set;

int min(int a, int b)
{
	return (a < b) ? a : b;
}

int min4(int a, int b, int c, int d)
{
	return min(min(a, b), min(c, d));
}

int max(int a, int b)
{
	return (a > b) ? a : b;
}

void swap(int& a, int& b)
{
	int q = a;
	a = b;
	b = q;
}

int main(int argc, char** argv)
{
	if(argc != 9)
	{
		printf("Usage: ./gen seed w h n q max_a non-multiple_allowed exterior_allowed\n");
		return 0;
	}
	
	int seed, w, h, n, q, max_a, mult_free, ext;
	sscanf(argv[1], "%d", &seed);
	sscanf(argv[2], "%d", &w);
	sscanf(argv[3], "%d", &h);
	sscanf(argv[4], "%d", &n);
	sscanf(argv[5], "%d", &q);
	sscanf(argv[6], "%d", &max_a);
	sscanf(argv[7], "%d", &mult_free);
	sscanf(argv[8], "%d", &ext);
	srand(seed);
	
	printf("%d %d\n", w, h);
	
	printf("%d\n", n);
	for(int i = 0; i < n; i++)
	{
		AGAIN:
		int x = rand() % w;
		int y = rand() % h;
		
		if(Set.find(TILE(x, y)) != Set.end())
		{
			goto AGAIN;
		}
		
		Set.insert(TILE(x, y));
		
		int max_d = (ext) ? (max(w, h) * 2) : (min4(x, y, (w - 1) - x, (h - 1) - y) + 1);
		int d = (rand() % max_d) + 1;
		int max_b = max_a / d;
		
		int a, b;
		if(max_b)
		{
			b = (rand() % max_b) + 1;
			a = b * d;
			if(mult_free) a -= rand() % b;
			a = min(a, max_a);
		}
		else
		{
			a = max_a;
			b = 1;
		}
		
		printf("%d %d %d %d\n", x + 1, y + 1, a, b);
	}
	
	printf("%d\n", q);
	for(int i = 0; i < q; i++)
	{
		int x1 = rand() % w;
		int x2 = rand() % w;
		
		if(x1 > x2)
		{
			swap(x1, x2);
		}
		
		int y1 = rand() % h;
		int y2 = rand() % h;
		
		if(y1 > y2)
		{
			swap(y1, y2);
		}
		
		printf("%d %d %d %d\n", x1 + 1, y1 + 1, x2 + 1, y2 + 1);
	}
	
	return 0;
}
