\ProvidesClass{ceoi}[2015]
\LoadClass{article}

\usepackage[a4paper,top=0.5in,bottom=0.8in,left=0.5in,right=0.5in]{geometry}
\usepackage[utf8]{inputenc}
\usepackage{graphicx}
\usepackage{amssymb}

\parindent=0.25in
\parskip=2pt plus 1pt minus 1pt

\usepackage{enumitem}
\setlist[1]{label=$\blacktriangleright$,rightmargin=\parindent}

\usepackage{indentfirst}
\usepackage{titlesec}
\titlespacing*{\subsection}{0pt}{2ex plus 0.5ex minus .5ex}{0.7ex plus 0.3ex}
\titlespacing*{\subsubsection}{0pt}{1ex plus 0.25ex minus .25ex}{0.35ex plus 0.15ex}

\newcommand{\task}[3]{
	\hbox to \hsize{%
		\hbox{\LARGE\bf #3}
		\hfil
		\vbox{\usefont{T1}{phv}{b}{n}\fontsize{7pt}{8pt}\selectfont
			\halign{\hfil##\cr
				DAY #1 TASK #2\cr
				\tasklang\cr
			}
			\vskip -1pt
		}
		\hskip 8pt
		\lower 3pt\hbox{\includegraphics[height=20pt]{../tex/logo.pdf}}
	}
	\vskip 1pt
	\hrule height 2pt
	\vskip 1pt
	\hrule height 0.5pt
	\bigskip
}

\newcommand{\tasklang}{ENGLISH}

\newcommand{\inputformat}{
	\subsection*{Input format}
}

\newcommand{\outputformat}{
	\subsection*{Output format}
}

\newcommand{\exampleinput}{
	\subsection*{Example input}
}

\newcommand{\exampleoutput}{
	\subsection*{Example output}
}

\newcommand{\examplenote}{
	\vskip -3pt
	\noindent
}

\newcommand{\grading}{
	\subsection*{Grading}
}
